# Contributing Guidelines

## How to contribute

If you would like to contribute to this project, see [Contributions to Splunk](https://www.splunk.com/en_us/form/contributions.html) for more information.

## Issues and bug reports

If you're seeing some unexpected behavior with this project, please create an [issue](https://github.com/splunk/splunk-sdk-javascript/issues) on GitHub with the following information:

1. Version of this project you're using (ex: 1.7.1)
2. Platform version (ex: Windows Server 2012)
3. Framework version (ex: Node.js v.0.12) or Browser (ex: Chrome 43.0.2357.81)
4. Splunk Enterprise version (ex: 7.0)
5. Other relevant information (ex: local/remote environment, Splunk network configuration, standalone or distributed deployment, are load balancers used)

Alternatively, if you have a Splunk question please ask on [Splunk Answers](https://community.splunk.com/t5/Splunk-Development/ct-p/developer-tools).

## Pull requests

We love to see pull requests!

To create a pull request:

1. Fill out the [Individual Contributor Agreement](https://www.splunk.com/en_us/form/contributions.html).
2. Fork the [repository](https://github.com/splunk/splunk-sdk-javascript).
3. Make changes to the **develop** branch, preferably with tests.
4. Create a [pull request](https://github.com/splunk/splunk-sdk-javascript/pulls) against the **develop** branch.

## Contact us

If you have a paid Splunk Enterprise or Splunk Cloud license, you can contact [Support](https://www.splunk.com/en_us/support-and-services.html) with questions.

You can reach the Splunk Developer Platform team at _devinfo@splunk.com_.

